   package grunddaten;
   import java.awt.*;
   import java.awt.event.*;

   public class WeltCanvas extends Canvas
   {
   // Variablen
      public boolean zeichneGrafikobjekte;
      final int RELATIVE_AUSGABEGROESSE = 8;
      private Welt myWelt = new Welt();
      private Objektaufstellung experiment;
      private Objektliste objekte;
      private Agentenliste agenten;
      private Point3d myGroesse = new Point3d();
      private int breite;
      private int laenge;
      private int raster;
   
   // Konstruktoren
      public WeltCanvas()
      {
         this(100,100);
      }
   
      public WeltCanvas(int breite_x, int laenge_y)
      {
         super();
         setSize((breite_x+2)*RELATIVE_AUSGABEGROESSE,(laenge_y+2)*RELATIVE_AUSGABEGROESSE);
         setBackground(Color.white);
         bereinigen();
      }
   
      public void setSize(int breite_x, int laenge_y)
      {
         super.setSize((breite_x+2)*RELATIVE_AUSGABEGROESSE,(laenge_y+2)*RELATIVE_AUSGABEGROESSE);
      }
   
   // Methoden
      public void bereinigen()
      {
         zeichneGrafikobjekte = false;
         repaint();
      }
   
      public void zeichnen()
      {
         zeichneGrafikobjekte = true;
      	experiment = null;
      	agenten = null;
         repaint();
      }
   
      public void zeichnen(Welt tempWelt)
      {
         myWelt = tempWelt;
         zeichneGrafikobjekte = true;
      	experiment = null;
      	agenten = null;
         repaint();
      }
   
      public void zeichnen(Welt tempWelt, Objektliste temp_obj, Objektaufstellung temperg)
      {
         myWelt = tempWelt;
         objekte = temp_obj;
         experiment = temperg;
      	agenten = null;
         zeichneGrafikobjekte = true;
         repaint();
      }  
   
   
      public void zeichnen(Welt tempWelt, Objektliste temp_obj, Objektaufstellung temperg, Agentenliste templist)
      {
         myWelt = tempWelt;
         objekte = temp_obj;
         experiment = temperg;
         agenten = templist;
         zeichneGrafikobjekte = true;
         repaint();
      }
   
      public void paint(Graphics g)
      
      {
      
         myGroesse = myWelt.ausgabe_groesse();
         breite = myGroesse.ausgabe_x();
         laenge = myGroesse.ausgabe_y();
         raster = myWelt.ausgabe_raster_k();
      
      
         if ((zeichneGrafikobjekte) && (myWelt != null) &&
         (myWelt.ausgabe_groesse().ausgabe_x() > 0) &&
         (myWelt.ausgabe_groesse().ausgabe_y() > 0)) {
         
            g.translate(RELATIVE_AUSGABEGROESSE,RELATIVE_AUSGABEGROESSE);
         
         // Zeichnen der Mauer
            g.setColor(Color.black);
            g.fillRect(-RELATIVE_AUSGABEGROESSE,-RELATIVE_AUSGABEGROESSE,RELATIVE_AUSGABEGROESSE*((breite*raster)+2),RELATIVE_AUSGABEGROESSE);
            g.fillRect(-RELATIVE_AUSGABEGROESSE,-RELATIVE_AUSGABEGROESSE,RELATIVE_AUSGABEGROESSE,RELATIVE_AUSGABEGROESSE*((laenge*raster)+2));
            g.fillRect(-RELATIVE_AUSGABEGROESSE,RELATIVE_AUSGABEGROESSE*laenge*raster,RELATIVE_AUSGABEGROESSE*((breite*raster)+2),RELATIVE_AUSGABEGROESSE);
            g.fillRect(RELATIVE_AUSGABEGROESSE*breite*raster,-RELATIVE_AUSGABEGROESSE,RELATIVE_AUSGABEGROESSE,RELATIVE_AUSGABEGROESSE*((laenge*raster)+2));
         
         // Zeichnen der Agentenfelder
            g.setColor(Color.gray);         
            if (breite > 0)
            {
               int i_x;
               for (i_x = 0; i_x <= breite*RELATIVE_AUSGABEGROESSE*raster; i_x = i_x+(RELATIVE_AUSGABEGROESSE))
                  g.drawLine(i_x,0,i_x,laenge*RELATIVE_AUSGABEGROESSE*raster);
            }
            if (laenge > 0)
            {
               int i_y;
               for (i_y = 0; i_y <= laenge*RELATIVE_AUSGABEGROESSE*raster; i_y = i_y+(RELATIVE_AUSGABEGROESSE))
                  g.drawLine(0,i_y,breite*RELATIVE_AUSGABEGROESSE*raster,i_y);
            }
         
         // Zeichnen der Objektfelder
            g.setColor(Color.red);
            if (breite > 0)
            {
               int i_x;
               for (i_x = 0; i_x <= breite*RELATIVE_AUSGABEGROESSE*raster; i_x = i_x+(RELATIVE_AUSGABEGROESSE*raster))
                  g.drawLine(i_x,0,i_x,laenge*RELATIVE_AUSGABEGROESSE*raster);
            }
            if (laenge > 0)
            {
               int i_y;
               for (i_y = 0; i_y <= laenge*RELATIVE_AUSGABEGROESSE*raster; i_y = i_y+(RELATIVE_AUSGABEGROESSE*raster))
                  g.drawLine(0,i_y,breite*RELATIVE_AUSGABEGROESSE*raster,i_y);
            }
         
         // Zeichnen der Sperrflaechen
            g.setColor(Color.black);
            int i = 0;
            while (myWelt.ausgabe_sperrflaechen_lo_x(i) >=  0) {
            
               g.fillRect(myWelt.ausgabe_sperrflaechen_lo_x(i)*RELATIVE_AUSGABEGROESSE,
                  myWelt.ausgabe_sperrflaechen_lo_y(i)*RELATIVE_AUSGABEGROESSE,
                  (myWelt.ausgabe_sperrflaechen_ru_x(i)-myWelt.ausgabe_sperrflaechen_lo_x(i))*RELATIVE_AUSGABEGROESSE+1,
                  (myWelt.ausgabe_sperrflaechen_ru_y(i)-myWelt.ausgabe_sperrflaechen_lo_y(i))*RELATIVE_AUSGABEGROESSE+1);         	
               i++;
            
            }
         
         // Zeichnen der Eingaenge
            g.setColor(Color.green);
            i = 0;
            while (myWelt.ausgabe_eingaenge_lo_x(i) >=  0) {
            
               g.fillRect(myWelt.ausgabe_eingaenge_lo_x(i)*RELATIVE_AUSGABEGROESSE,
                  myWelt.ausgabe_eingaenge_lo_y(i)*RELATIVE_AUSGABEGROESSE,
                  (myWelt.ausgabe_eingaenge_ru_x(i)-myWelt.ausgabe_eingaenge_lo_x(i))*RELATIVE_AUSGABEGROESSE+1,
                  (myWelt.ausgabe_eingaenge_ru_y(i)-myWelt.ausgabe_eingaenge_lo_y(i))*RELATIVE_AUSGABEGROESSE+1);         	
               i++;
            
            }
         
         // Zeichnen der Ausgaenge
            g.setColor(Color.blue);
            i = 0;
            while (myWelt.ausgabe_ausgaenge_lo_x(i) >=  0) {
            
               g.fillRect(myWelt.ausgabe_ausgaenge_lo_x(i)*RELATIVE_AUSGABEGROESSE,
                  myWelt.ausgabe_ausgaenge_lo_y(i)*RELATIVE_AUSGABEGROESSE,
                  (myWelt.ausgabe_ausgaenge_ru_x(i)-myWelt.ausgabe_ausgaenge_lo_x(i))*RELATIVE_AUSGABEGROESSE+1,
                  (myWelt.ausgabe_ausgaenge_ru_y(i)-myWelt.ausgabe_ausgaenge_lo_y(i))*RELATIVE_AUSGABEGROESSE+1);         	
               i++;
            
            }
         
            //Zeichnen der Agenten
            if (agenten != null) {
            
               int pos_x;
               int pos_y;
            
               i = 0;
               while (agenten.agenten_ausgeben(i) != null) {
               
                  if ((agenten.agenten_ausgeben(i).ausgabe_status() != null) &&
                  (agenten.agenten_ausgeben(i).ausgabe_status().ausgabe_status() != null)) {
                     pos_x = ((((agenten.agenten_ausgeben(i)).ausgabe_status()).ausgabe_status()).ausgabe_position()).ausgabe_x();
                     pos_y = ((((agenten.agenten_ausgeben(i)).ausgabe_status()).ausgabe_status()).ausgabe_position()).ausgabe_y();
                  
                     pos_x = pos_x*RELATIVE_AUSGABEGROESSE+1;
                     pos_y = pos_y*RELATIVE_AUSGABEGROESSE+1;
                  
                     g.setColor(Color.gray);
                  
                     g.fillRect(pos_x, pos_y,
                        RELATIVE_AUSGABEGROESSE-1, RELATIVE_AUSGABEGROESSE-1);
                  
                     g.setColor(Color.white);
                  
                     switch((((agenten.agenten_ausgeben(i)).ausgabe_status()).ausgabe_status()).ausgabe_ausrichtung()) {
                        case 'N':
                           g.fillOval(pos_x+2, pos_y,
                              RELATIVE_AUSGABEGROESSE-4, 4); 
                           break;
                        case 'O':
                           g.fillOval(pos_x+RELATIVE_AUSGABEGROESSE-4, pos_y+2,
                              4, RELATIVE_AUSGABEGROESSE-4); 
                           break;
                        case 'S':
                           g.fillOval(pos_x+2, pos_y+RELATIVE_AUSGABEGROESSE-4,
                              RELATIVE_AUSGABEGROESSE-4, 4); 
                           break;
                        case 'W':
                           g.fillOval(pos_x, pos_y+2,
                              4, RELATIVE_AUSGABEGROESSE-4); 
                     }
                  }
                  i++;
               }
            }
         
         	// Zeichnen der Objekte
            if (experiment != null) {
            
               int id;
            
               int pos_x;
               int pos_y;
               int obj_lg;
               int obj_br;
            
               i = 0;
               while (experiment.ausgabe_eintrag(i) != null) {
               
                  id = experiment.ausgabe_eintrag(i).ausgabe_id();
               
                  pos_x = (((experiment.ausgabe_eintrag(i)).ausgabe_status()).ausgabe_position()).ausgabe_x();
                  pos_y = (((experiment.ausgabe_eintrag(i)).ausgabe_status()).ausgabe_position()).ausgabe_y();
               
                  if ((pos_x >= 0) && (pos_y >= 0)) {
                  
                     pos_x = pos_x*raster*RELATIVE_AUSGABEGROESSE+1;
                     pos_y = pos_y*raster*RELATIVE_AUSGABEGROESSE+1;
                  
                     obj_lg = objekte.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_x();
                     obj_br = objekte.objekt_ausgeben_id(id).ausgabe_groesse().ausgabe_y();
                  
                     g.setColor(Color.gray);
                  
                     g.fillRect(pos_x, pos_y,
                        obj_lg*raster*RELATIVE_AUSGABEGROESSE-1,
                        obj_br*raster*RELATIVE_AUSGABEGROESSE-1);
                  
                     g.setColor(Color.yellow);
                  
                     switch(((experiment.ausgabe_eintrag(i)).ausgabe_status()).ausgabe_ausrichtung()) {
                        case 'N':
                           g.fillRect(pos_x+2, pos_y,
                              obj_lg*RELATIVE_AUSGABEGROESSE*raster-5, 2); 
                           break;
                        case 'O':
                           g.fillRect(pos_x+(obj_lg*RELATIVE_AUSGABEGROESSE*raster)-3, pos_y+2,
                              2, (obj_br*RELATIVE_AUSGABEGROESSE*raster)-5); 
                           break;
                        case 'S':
                           g.fillRect(pos_x+2, pos_y+(obj_br*RELATIVE_AUSGABEGROESSE*raster)-3,
                              (obj_lg*RELATIVE_AUSGABEGROESSE*raster)-5, 2); 
                           break;
                        case 'W':
                           g.fillRect(pos_x, pos_y+2,
                              2, (obj_br*RELATIVE_AUSGABEGROESSE*raster)-5); 
                     }
                  }
                  i++;
               }
            }
         
         
            g.translate(-RELATIVE_AUSGABEGROESSE,-RELATIVE_AUSGABEGROESSE);
         
         }
      }
   
      private Image offScreenImage;
      private Graphics offScreenGraphics;
      private Dimension offScreenSize;
      protected Color color = Color.white;
   
      public final synchronized void update (Graphics theG)
      {
         Dimension d = getSize();
         if((offScreenImage == null) || (d.width != offScreenSize.width) ||
         (d.height != offScreenSize.height)) 
         {
            offScreenImage = createImage(d.width, d.height);
            offScreenSize = d;
            offScreenGraphics = offScreenImage.getGraphics();
            offScreenGraphics.setFont(getFont());
         }
         offScreenGraphics.setColor(color);
         offScreenGraphics.fillRect(0,0,d.width, d.height);
         offScreenGraphics.setColor(Color.black);
         paint(offScreenGraphics);
         theG.drawImage(offScreenImage,0,0, null);
      }
   }