// Reprsentation eines GA's:
// Hier werden die Chromosomenlaengen, Mutationswahrscheinlichenkeiten, ...
// definiert.
// Weiters gibt es zwei Konvertierungsfunktionen:
//  1.)Inidividuum -> Objektaufstellung
//  2.)Objektaufstellung -> Inidividuum 

package ga;

import java.util.Random;
import java.util.BitSet;
import grunddaten.*;
import oop.hauptfenster;



public class GA {

   // Zufallsgenerator fr Mutation und Crossover
   static Random r;
   // seedwert fr den Zufallsgenerator
   static long seed;
   // Chromosomenlaenge des Cromosoms1
   static int chromlaenge_C1;
   // Chromosomenlaenge des Cromosoms2
   static int chromlaenge_C2;
   // Chromosomenlaenge des Cromosoms3
   static int chromlaenge_C3;
   // Populationsgrsse
   static int populationsgroesse;
       

   // Konstruktor
   public GA(int laenge_C1, int laenge_C2, long n_seed, int pop_size) {
      chromlaenge_C1 = laenge_C1;
      chromlaenge_C2 = laenge_C2;
      chromlaenge_C3 = 2*chromlaenge_C2;
      seed = n_seed;
      r = new Random(seed);
	  populationsgroesse = pop_size;	  
     
  
   }
   
   
   //___________________________________________________________________
   // Entscheidung ob eine Mutation durchgfhrt wird oder nicht
   public static boolean mutiere (int laenge)
   {
      return (r.nextDouble() <= laenge/2.0);
   }
   
   
   
   //___________________________________________________________________
   // Entscheidung ob eine Mutation durchgfhrt wird oder nicht
   public static boolean mutiere_C13 (int laenge)
   {
      return (r.nextDouble() <= 1.0/laenge);
   }
   
   //___________________________________________________________________
   // Entscheidung ob eine Mutation durchgfhrt wird oder nicht
   public static boolean mutiere_C2 (int laenge)
   {
      return (r.nextDouble() <= 1.0/laenge);
   }



   //___________________________________________________________________
   // liefert eine Crossoverstelle
   public static int c_punkt (int laenge)
   {
      return r.nextInt(laenge);
   }

   //___________________________________________________________________
   // liefert einen zuflligen double-Wert
   public static double next_double ()
   {
      return r.nextDouble();
   }

	
	//___________________________________________________________________
   // Gerneriert aus einer Objeketaufstellung ein Individuum (3 Chromosomen)
   public Individuum konvertiere (hauptfenster myhaupt, Objektaufstellung myAufstellung)
   {
    int n, p2=0, p3=0, i, besetzt, anzahl, min, min_n;
    char temp_c;
    int temp_i;
    boolean enthalten = false;
    Point3d temp_pos;
    Individuum myIndividuum;
    
    // beeinhaltet alle Objektenummer (nicht id's) sortiert nach der Position
    int[] sort = new int[chromlaenge_C2];
        
    // Chromosom1: freie Positionen, wo Objekte platziert werden knnen
    BitSet temp_1 = new BitSet(chromlaenge_C1);
    
    // Chromosom2: Objket_ids
    int[] temp_2 = new int[chromlaenge_C2];
    
    // Chromosom3: Objektausrichtungen
    BitSet temp_3 = new BitSet(chromlaenge_C3);
    
    
    // Dimension der Welt
    int dim_x = myhaupt.myWelt.ausgabe_groesse().ausgabe_x();
    int k = myhaupt.myWelt.ausgabe_raster_k();
    int dim = dim_x * myhaupt.myWelt.ausgabe_groesse().ausgabe_y(); 
    
    
    // sortiere Objekte 
    min = 0; anzahl = 0; min_n = -1;
    while (min != dim) {
      min = dim;
      for (n=0; myAufstellung.ausgabe_eintrag(n) != null; n++){ 
    	// berprfe, ob Objekt schon in der Liste vorhanden ist 
    	enthalten = false;
    	for (i=0; i<anzahl; i++)
    		if (n == sort[i])
    			enthalten = true;  
    	
    	// Objektposition 
    	temp_pos = myAufstellung.ausgabe_eintrag(n).ausgabe_status().ausgabe_position();
    	if (temp_pos != null && !enthalten) {
    		if (min > (temp_pos.ausgabe_y()*dim_x + temp_pos.ausgabe_x())){
    			min_n = n;
    			min = (temp_pos.ausgabe_y()*dim_x + temp_pos.ausgabe_x());}
    	}
      }	
      if (min != dim)
      	sort[anzahl++] = min_n; 
      	
    }  		
   
   
    // alle aufgestellten Objekte in das Chromosom1, 2 und 3 schreiben 
    for (n=0; n<anzahl; n++) { 
    	
    
    	// Objekt_id (Chromosom2)
    	temp_2[p2++] = myAufstellung.ausgabe_eintrag(sort[n]).ausgabe_id();
    	
    	// Objektposition (Chromosom1)
    	temp_pos = myAufstellung.ausgabe_eintrag(sort[n]).ausgabe_status().ausgabe_position();
    	if (temp_pos != null) {
    		besetzt = myhaupt.besetzte(temp_pos);
    		temp_1.set(temp_pos.ausgabe_y()*myhaupt.myWelt.ausgabe_groesse().ausgabe_x() 
    		               + temp_pos.ausgabe_x() - besetzt);
    		               
    	}
    	    	
    	// Objektausrichtung (Chromosom3)
    	temp_c = myAufstellung.ausgabe_eintrag(sort[n]).ausgabe_status().ausgabe_ausrichtung();
    	switch (temp_c) {
    		case 'N':  temp_3.clear(p3++); temp_3.clear(p3++); break;
    		case 'O':  temp_3.clear(p3++); temp_3.set(p3++); break;
    		case 'S':  temp_3.set(p3++); temp_3.clear(p3++); break;
    		case 'W':  temp_3.set(p3++); temp_3.set(p3++); break;
    	}

    }	
   
    // alle nicht aufgestellten Objekte in das Chromosom2 und 3schreiben 
    n=0;
    while (myhaupt.myObjektliste.objekt_ausgeben(n) != null) { 
    	
    	// berprfe, ob Objekt bereits in der Liste vorhanden ist
    	enthalten = false;
    	for (i=0; i<p2; i++)
    		if (temp_2[i] == myhaupt.myObjektliste.objekt_ausgeben(n).ausgabe_id())
    			{enthalten = true; i= p2;}
   		
   		// Fge Objekt hinzu
   		if (!enthalten) {
   			// Objektnummer
    		temp_2[p2++] = myhaupt.myObjektliste.objekt_ausgeben(n).ausgabe_id();
    		// Objektausrichtung (Zufllig erzeugen)
    		temp_i = r.nextInt(4);
    		switch (temp_i) {
    			case 0:  temp_3.clear(p3++); temp_3.clear(p3++); break;
    			case 1:  temp_3.clear(p3++); temp_3.set(p3++); break;
    			case 2:  temp_3.set(p3++); temp_3.clear(p3++); break;
    			case 3:  temp_3.set(p3++); temp_3.set(p3++); break;
			}    	
    	} 
       	n++;
	}      
      
      // die konvertierte Aufstellung    
      myIndividuum = new Individuum(temp_1, temp_2, temp_3, myAufstellung.ausgabe_fitness());
      
      return myIndividuum;
   }



//___________________________________________________________________
   // Gerneriert aus einem Individuum (3 Chromosomen) eine Objeketaufstellung
   public Objektaufstellung konvertiere (Individuum myIndividuum, hauptfenster myhaupt )
   {	
   		int i, besetzt, p_c2, l_c2;
   		char ausr;
		Point3d t_point3d, von, bis;
		Status t_status;
		ObjektStatus t_objektstatus;
				
		Objektaufstellung myAufstellung = new Objektaufstellung();
    	
    	BitSet c1 = myIndividuum.chrom1().chrom();
    	int [] c2 = myIndividuum.chrom2().chrom();
    	BitSet c3 = myIndividuum.chrom3().chrom();
    	l_c2 = myIndividuum.chrom2().length();
    	    	
        // Dimension der Welt
        int dim_x = myhaupt.myWelt.ausgabe_groesse().ausgabe_x();
        int k = myhaupt.myWelt.ausgabe_raster_k();
        int dim = dim_x * 
        	  myhaupt.myWelt.ausgabe_groesse().ausgabe_y(); 

    	besetzt = 0;
    	for (i=0, p_c2=0; i<dim && p_c2 < l_c2  ; i++) {
    		// ist der Punkt besetzt
    		von = new Point3d((i%dim_x)*k, (i/dim_x)*k,0);
            bis = new Point3d((i%dim_x)*k+k, (i/dim_x)*k+k,0);            	
            
            // Falls die Flaeche frei ist erhoehe
      		if (!myhaupt.ist_frei(von, bis))
    			besetzt++;
    		// andernfalls berprfe, ob ein Objekt auf diesem Punkt ist
    		else if (c1.get(i-besetzt)) {
    			// Position
    			t_point3d = new Point3d(i%dim_x, i/dim_x, 0);
    			// Ausrichtung
    			if (c3.get(p_c2*2)) {
    				if (c3.get(p_c2*2+1))
    					ausr = 'W';	
    				else ausr = 'S';
    			}
    			else {
    				if (c3.get(p_c2*2+1))
    					ausr = 'O';
    				else ausr = 'N';
    			}
    			
    			t_status = new Status(ausr, t_point3d);
    			// Objekt_id
    			//System.out.println("ID: " + c2[p_c2]);
    			t_objektstatus = new ObjektStatus(c2[p_c2++], t_status);
    			
    			// zur Objektaufstellung hinzufgen
    			myAufstellung.hinzufuegen_eintrag(t_objektstatus);
    		}				
    		
    	}		
    	
    	// Fitnesswert
    	myAufstellung.aendere_fitness(myIndividuum.ausgabe_fitness());
    	
      	return myAufstellung;
   }

}



