/* - abkuerzungen: lo := linke obere ecke einer flaeche
                   ru := rechte untere ecke einer flaeche
		   lo_x(y,z): bezeichnet die x(y,z)-koordinate des linken-oberen punktes einer flaeche
		   ru_x(y,z): bezeichnet die x(y,z)-koordinate des rechten-unteren punktes einer flaeche

   - speicherung ein-, ausgaenge und sperrflaechen:
                   die flaechen werden mit 2 koordinaten festgelegt - die lo ecke und die ru ecke
                   diese koordinaten liegen in einem array der groesse 2 
                   arrayposition 0 := lo ecke
                   arrayposition 1 := ru ecke
                   die array's werden in einem vector gelistet. auf die einzelnen element kann ueber
		   die vectornummerierung zugegriffen werden.
*/


   package grunddaten;

/* Generated by Together */
   import java.util.Vector;

   public class Welt {
   
      private Point3d groesse       = new Point3d();
      private int     raster_k      = 0;      
      private Vector  eingaenge     = new Vector();
      private Vector  ausgaenge     = new Vector();
      private Vector  sperrflaechen = new Vector();
   
    /**
     * @stereotype constructor 
     */
   
    //konstruktor ohne angabe von initialwerten:   
      public Welt() {
      
         groesse.x = 0;
         groesse.y = 0;
         groesse.z = 0;
         raster_k = 0;
      }
   
    //konstruktor mit angabe von weltgroesse und raster_k
      public Welt(Point3d groesse, int raster_k) {
      
      //konstruieren der groesse:
         this.groesse.x = groesse.x;
         this.groesse.y = groesse.y;
         this.groesse.z = groesse.z;
      
      //konstruieren des rasters:
         this.raster_k = raster_k;
      }
   
    //konstruktor mit angabe aller initialwerte:
      public Welt(Point3d groesse, int raster, Vector eingang, Vector ausgang, Vector sperrflaechen) {
      
        //konstruieren der groesse:
         this.groesse.x = groesse.x;
         this.groesse.y = groesse.y;
         this.groesse.z = groesse.z;
      
        //konstruieren des rasters:
         raster_k = raster;
      
        //konstruieren der ein- und ausgaenge:
         eingaenge =      eingang;
         ausgaenge =      ausgang;
      
        //konstruieren der sperrflaechen:
         this.sperrflaechen = sperrflaechen;
      
      
      }
   
    //ausgabe der groesse:
      public Point3d ausgabe_groesse() {
         return groesse;
      }
   
    //ausgabe der rastergroesse k (Agentenwelt):
      public int ausgabe_raster_k() {
         return raster_k;
      }
   
    //methoden fuer eingaenge:
    //##############################################################
   
    //hinzufuegen eines einganges (lo + ru) am ende der liste:
    //lo := point3d an der oberen linken ecke
    //ru := point3d an der unteren rechten ecke
      public void hinzufuegen_eingaenge(Point3d lo, Point3d ru) {
         Point3d element [];
         element = new Point3d[2];
         element [0] = lo;
         element [1] = ru;
         eingaenge.addElement(element); 
	 
	 //test:
	 //int test = eingaenge.size();
	 //System.out.println("groesse eingangsvektor: " + test);
      }
   
    //hinzufuegen eines einganges (1 Point3d) am ende der liste:
    //lo und ru bekommt denselben wert
      public void hinzufuegen_eingaenge(Point3d lo_ru) {
         Point3d element [];
         element = new Point3d[2];
         element [0] = lo_ru;
         element [1] = lo_ru; 
         eingaenge.addElement(element);

	
      }

       //entfernen aller eingaenge:
       public void eingaengeliste_loeschen() {
	   eingaenge.clear();
       }
   
    //ausgabe des einganges als Point3d links-oben (lo) an der stelle position:
      public Point3d ausgabe_eingaenge_lo(int position) {
         if (position >= (eingaenge.size()))
         {   
            Point3d fehler = new Point3d();
            return fehler;//ausnahmebehandlung!!!!!!
         }
         else
         {
            Point3d element[];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo;
         }
      }
   
    //ausgabe des einganges als Point3d rechts-unten (ru) an der stelle position:
      public Point3d ausgabe_eingaenge_ru(int position) {
         if (position >= (eingaenge.size()))
         {   
            Point3d fehler = new Point3d();
            return fehler;//ausnahmebehandlung!!!!!!
         }
         else
         {
            Point3d element[];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru;
         }
      }
   
   
    //ausgabe der x-koordinate des einganges links-oben (lo) an der stelle position:  
      public int ausgabe_eingaenge_lo_x(int position) {
         if (position >= (eingaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.x;
         
         }
      }
   
    //ausgabe der y-koordinate des einganges links-oben (lo) an der stelle position:  
      public int ausgabe_eingaenge_lo_y(int position) {
         if (position >= (eingaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.y;
         
         }
      }
   
    //ausgabe der z-koordinate des einganges links-oben (lo) an der stelle position:  
      public int ausgabe_eingaenge_lo_z(int position) {
         if (position >= (eingaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.z;
         
         }
      }
   
   
   
    //ausgabe der x-koordinate des einganges rechts-unten (ru) an der stelle position:  
      public int ausgabe_eingaenge_ru_x(int position) {
         if (position >= (eingaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.x;
         
         }
      }
   
      //ausgabe der z-koordinate des einganges rechts-unten (ru) an der stelle position:  
      public int ausgabe_eingaenge_ru_z(int position) {
         if (position >= (eingaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.z;
         
         }
      }
   
      //ausgabe der y-koordinate des einganges rechts-unten(ru) an der stelle position:  
      public int ausgabe_eingaenge_ru_y(int position) {
         if (position >= (eingaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) eingaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.y;
         
         }
      }
   
   
    //entfernt eingang (lo + ru) an der stelle position:
    //achtung!!! vectornummerierung verschiebt sich!!!!!!!
      public void entfernen_eingaenge(int position) {
         if (position >= (eingaenge.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            eingaenge.remove(position);
         }
      }
   
    //aendert eingang (lo + ru) an der stelle position:
      public void aendern_eingaenge(Point3d lo, Point3d ru, int position) {
         if (position >= (eingaenge.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element []; //array aus Point3d's
            element = new Point3d[2]; //array der groesse 2
            element [0] = lo;
            element [1] = ru;
            eingaenge.setElementAt(element, position);
         }
      }
   
    //aendert eingang (1 point3d) an der stelle position:
      public void aendern_eingaenge(Point3d lo_ru, int position) {
         if (position >= (eingaenge.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element []; //array aus Point3d's
            element = new Point3d[2]; //array der groesse 2
            element [0] = lo_ru;
            element [1] = lo_ru;
            eingaenge.setElementAt(element, position);
         }
      }
   
   
    //Methoden fuer ausgaenge:
    //##############################################
   
    //hinzufuegen eines ausganges (lo + ru) am ende der liste:
      public void hinzufuegen_ausgaenge(Point3d lo, Point3d ru) {
         Point3d element [];
         element = new Point3d[2];
         element [0] = lo;
         element [1] = ru;
         ausgaenge.addElement(element);
      }
   
    //hinzufuegen eines ausganges (1 point3d) am ende der liste:
      public void hinzufuegen_ausgaenge(Point3d lo_ru) {
         Point3d element [];
         element = new Point3d[2];
         element [0] = lo_ru;
         element [1] = lo_ru; //bei angabe nur eines punktes ist lo + ru gleich
         ausgaenge.addElement(element);
      }

         //entfernen aller ausgaenge:
       public void ausgaengeliste_loeschen() {
	   ausgaenge.clear();
       }
   
    //ausgabe des ausganges links-oben als point3d an der stelle position:
      public Point3d ausgabe_ausgaenge_lo(int position) {
         if (position >= (ausgaenge.size()))
         {   
            Point3d fehler = new Point3d();
            return fehler;//ausnahmebehandlung!!!!!!
         }
         else
         {
            Point3d element[];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo;
         }
      }
   
    //ausgabe des ausganges rechts-unten als point3d an der stelle position:
      public Point3d ausgabe_ausgaenge_ru(int position) {
         if (position >= (ausgaenge.size()))
         {   
            Point3d fehler = new Point3d();
            return fehler;//ausnahmebehandlung!!!!!!
         }
         else
         {
            Point3d element[];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru;
         }
      }
   
    //ausgabe der x-koordinate des ausganges rechts-unten (ru) an der stelle position:  
      public int ausgabe_ausgaenge_ru_x(int position) {
         if (position >= (ausgaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.x;
         
         }
      }
   
    //ausgabe der y-koordinate des ausganges rechts-unten (ru) an der stelle position:  
      public int ausgabe_ausgaenge_ru_y(int position) {
         if (position >= (ausgaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.y;
         }
      }
   
    //ausgabe der z-koordinate des ausganges rechts-unten (ru) an der stelle position:  
      public int ausgabe_ausgaenge_ru_z(int position) {
         if (position >= (ausgaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.z;
         }
      }
   
   
   
    //ausgabe der x-koordinate des ausganges links-oben (lo) an der stelle position:  
      public int ausgabe_ausgaenge_lo_x(int position) {
         if (position >= (ausgaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.x;
         
         }
      }
   
    //ausgabe der z-koordinate des ausganges links-oben (lo) an der stelle position:  
      public int ausgabe_ausgaenge_lo_z(int position) {
         if (position >= (ausgaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.z;
         
         }
      }
   
    //ausgabe der y-koordinate des ausganges links-oben (lo) an der stelle position:  
      public int ausgabe_ausgaenge_lo_y(int position) {
         if (position >= (ausgaenge.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) ausgaenge.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.y;
         
         }
      }
   
    //aendern des ausganges an der stelle position (links-oben und rechts-unten):
      public void aendern_ausgaenge(Point3d lo, Point3d ru, int position) {
         if (position >= (ausgaenge.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];       //array aus Point3d's
            element = new Point3d[2]; //array der groesse 2
            element [0] = lo;
            element [1] = ru;
            ausgaenge.setElementAt(element, position);
         }
      }
   
    //aendern des ausganges an der stelle position (1 point3d):
      public void aendern_ausgaenge(Point3d lo, int position) {
         if (position >= (ausgaenge.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];       //array aus Point3d's
            element = new Point3d[2]; //array der groesse 2
            element [0] = lo;
            element [1] = lo;
            ausgaenge.setElementAt(element, position);
         }
      }
   
    // entfernt ausgang (lo + ru) an der stelle position:
    // achtung: nummerierung des vectors aendert sich!!!!!
      public void entfernen_ausgang(int position) {
         if (position >= (ausgaenge.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            ausgaenge.remove(position);
         }
      }
   
    /*methoden fuer sperrflaechen:
      ##########################################################
      
      hinzufuegen einer sperrflache (lo + ru):*/
      public void hinzufuegen_sperrflaechen(Point3d lo, Point3d ru) {
         Point3d element [];
         element = new Point3d[2];
         element [0] = lo;
         element [1] = ru;
         sperrflaechen.addElement(element);
      }
   
    //hinzufuegen einer sperrflache (1 point3d):
      public void hinzufuegen_sperrflaechen(Point3d lo_ru) {
         Point3d element [];
         element = new Point3d[2];
         element [0] = lo_ru;
         element [1] = lo_ru; //bei angabe nur eines punktes ist lu + ro gleich.
         sperrflaechen.addElement(element);
      }
   
         //entfernen aller sperrflaechen:
       public void sperrflaechenliste_loeschen() {
	   sperrflaechen.clear();
       }

    //ausgabe der sperrflaeche als Point3d links-oben an der stelle position:
      public Point3d ausgabe_sperrflaechen_lo(int position) {
         if (position >= (sperrflaechen.size()))
         {   
            Point3d fehler = new Point3d();
            return fehler;//ausnahmebehandlung!!!!!!
         }
         else
         {
            Point3d element[];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo;
         }
      }
   
    //ausgabe der sperrflaechen  als Point3d rechts-unten an der stelle position:
      public Point3d ausgabe_sperrflaechen_ru(int position) {
         if (position >= (sperrflaechen.size()))
         {   
            Point3d fehler = new Point3d();
            return fehler;//ausnahmebehandlung!!!!!!
         }
         else
         {
            Point3d element[];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru;
         }
      }
   
   
    //ausgabe der x-koordinate der sperrflaechen rechts-unten (ru) an der stelle position:  
      public int ausgabe_sperrflaechen_ru_x(int position) {
         if (position >= (sperrflaechen.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.x;
         
         }
      }
   
     //ausgabe der y-koordinate der sperrflaechen rechts-unten (ru) an der stelle position:  
      public int ausgabe_sperrflaechen_ru_y(int position) {
         if (position >= (sperrflaechen.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.y;
         
         }
      }
   
    //ausgabe der z-koordinate der sperrflaechen rechts-unten (ru) an der stelle position:  
      public int ausgabe_sperrflaechen_ru_z(int position) {
         if (position >= (sperrflaechen.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d ru = new Point3d();
            ru = (Point3d) element[1];
            return ru.z;
         
         }
      }
   
   
   
   //ausgabe der x-koordinate des ausganges links-oben (lo) an der stelle position:  
      public int ausgabe_sperrflaechen_lo_x(int position) {
         if (position >= (sperrflaechen.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.x;
         
         }
      }
   
    //ausgabe der y-koordinate der sperrflaechen links-oben (lo) an der stelle position:  
      public int ausgabe_sperrflaechen_lo_y(int position) {
         if (position >= (sperrflaechen.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.y;
         }
      }
   
    //ausgabe der z-koordinate der sperrflaechen links-oben (lo) an der stelle position:  
      public int ausgabe_sperrflaechen_lo_z(int position) {
         if (position >= (sperrflaechen.size()))
         {
            return -1;}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element [];
            element = new Point3d[2];
            element = (Point3d[]) sperrflaechen.elementAt(position);
            Point3d lo = new Point3d();
            lo = (Point3d) element[0];
            return lo.z;
         }
      }
   
   
   
    //aendern der sperrflaeche lo + ru an der stelle position:
      public void aendern_sperrflaechen(Point3d lo, Point3d ru, int position) {
         if (position >= (sperrflaechen.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element []; //array aus Point3d's
            element = new Point3d[2]; //array der groesse 2
            element [0] = lo;
            element [1] = ru;
            sperrflaechen.setElementAt(element, position);
         }
      }
   
    //aendern der sperrflaeche (1 point3d) an der stelle position:
      public void aendern_sperrflaechen(Point3d lo_ru, int position) {
         if (position >= (sperrflaechen.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            Point3d element []; //array aus Point3d's
            element = new Point3d[2]; //array der groesse 2
            element [0] = lo_ru;
            element [1] = lo_ru;
            sperrflaechen.setElementAt(element, position);
         }
      }
   
   
    //entfernt sperrflaeche (lo + ru) an der stelle position:
      public void entfernen_sperrflaechen(int position) {
         if (position >= (sperrflaechen.size()))
         {}//ausnahmebehandlung!!!!!!!
         else {
            sperrflaechen.remove(position);
         }
      }
   
      
   
    //ende methoden fuer sperrflaechen
    //###################################################################
   
   
   //aendern der groesse + raster(laenge, breitem hoehe, raster):
      public void aendern_groesse_raster(Point3d groesse, int raster_k) {
         this.groesse = groesse;
         this.raster_k = raster_k;
      }
   
   
   
   }
